hdu 1186(搜索+HASH)

方程的解数

Time Limit: 15000MS   Memory Limit: 128000K
Total Submissions: 7045   Accepted: 2417
Case Time Limit: 5000MS

Description

已知一个n元高次方程:

其中:x1, x2,...,xn是未知数,k1,k2,...,kn是系数,p1,p2,...pn是指数。且方程中的所有数均为整数。

假设未知数1 <= xi <= M, i=1,,,n,求这个方程的整数解的个数。

1 <= n <= 6;1 <= M <= 150。

方程的整数解的个数小于231

★本题中,指数Pi(i=1,2,...,n)均为正整数。

Input

第1行包含一个整数n。第2行包含一个整数M。第3行到第n+2行,每行包含两个整数,分别表示ki和pi。两个整数之间用一个空格隔开。第3行的数据对应i=1,第n+2行的数据对应i=n。

Output

仅一行,包含一个整数,表示方程的整数解的个数。

Sample Input

3
150
1  2
-1  2
1  2

Sample Output

178

由于6个数的搜索的层数最多会达到150^6..所以不可行,好的方法是将前3个数组合所有的解算出来并存入HASH表,然后算出后三个数的所有组合,每次对(-ans)进行查找,不过咏链式前向星构造的果断不行看了别人的代码发现一个构造HASH表的很好的模板。
/*
6
150
1  2
-1  2
1  2
-1  2
1  2
-1  2
*/
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<math.h>
#include<queue>
#include<iostream>
using namespace std;
const int INF = 999999999;
const int N = 151*151*151;
int k[10],p[10];
int n,m,cnt,mid;
/*************构造HASH表****************/
bool used[N];
struct Hash{
    int val;
    int cnt;
}HashTable[N];
void initHash(){
    memset(used,false,sizeof(used));
    memset(HashTable,0,sizeof(HashTable));
}
int SearchHash(int v)
{
    int temp = v;
    while(temp<0) temp+=N;
    while(temp>=N) temp-=N;
    while(used[temp]&&HashTable[temp].val!=v){
        temp++;
        if(temp>=N) temp-=N;
     }
    return temp;
}
void InsertHash(int v)
{
    int pos = SearchHash(v);
    HashTable[pos].val = v;
    used[pos] = true;
    HashTable[pos].cnt++;
}
/*****************************************/
int pow(int a,int n)
{
    int ans = 1;
    while(n)
    {
        if(n&1) ans = ans*a;
        a = a*a;
        n>>=1;
    }
    return ans;
}
void dfs(int step,int ans)
{
    if(step==mid)
    {
        InsertHash(ans);
        return ;
    }
    else
    {
        for(int i=1; i<=m; i++)
        {
            dfs(step+1,ans + k[step]*pow(i,p[step]));
        }
    }
}
void dfs2(int step,int ans)
{
    if(step==n+1)
    {
        ans = -ans;
        int s = SearchHash(ans);
        if(HashTable[s].val == ans){
            cnt+=HashTable[s].cnt;
        }
        return ;
    }
    else
    {
        for(int i=1; i<=m; i++)
        {
            dfs2(step+1,ans + k[step]*pow(i,p[step]));
        }
    }
}
int main()
{

    while(scanf("%d%d",&n,&m)!=EOF)
    {
        initHash();
        cnt = 0;
        for(int i=1; i<=n; i++)
        {
            scanf("%d%d",&k[i],&p[i]);
        }
        if(n==1){
            printf("%d\n",0);
            continue;
        }
        mid = n/2+1;
        dfs(1,0);
        dfs2(mid,0);
        printf("%d\n",cnt);
    }
    return 0;
}
				
时间: 2024-12-21 00:55:36

hdu 1186(搜索+HASH)的相关文章

50道hdu基础搜索总结(转)

Dfs: 大部分是直接递归枚举,即求满足约束条件下的解,虽不用剪枝,但也需要代码能力. 练习递归枚举的题目: 1241       Oil Deposits (dfs的连通块个数) 1016       Prime Ring Problem 1584       蜘蛛牌(简单dfs,简单的剪枝,还有人用DP做(???)) 1426       Sudoku Killer(练习递归的好题目 or Dancing links(???)) 2510       符号三角形(打表题,写写打表程序还是不错

hdu 5887 搜索+剪枝

Herbs Gathering Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 687    Accepted Submission(s): 145 Problem Description Collecting one's own plants for use as herbal medicines is perhaps one of t

hdu 4941 STL HASH 模拟

http://acm.hdu.edu.cn/showproblem.php?pid=4941 比赛的时候现学的map的find...以前都是用下标做的,但是map用下标查询的话,如果查询的元素不存在,会插入一个新的元素. 贴一个map查找元素找到和找不到的模板 map<pair<int,int>,int>::iterator it=poshash.find(tmppos);//pair<int,int>poshash; int pp; if(it == poshash.

HDU 4821 (hash)

这道题最重要的不仅是hash这种算法,更要学会利用好STL中的<map>才行. 将连续的L个字符经过hash赋值,最后线性判断.其中的判断步骤用到了map的插入特性. #include <iostream> #include <cstdio> #include <algorithm> #include <cstring> #include <map> using namespace std; #define maxn 500010 #

poj 1198 hdu 1401 搜索+剪枝 Solitaire

写到一半才发现可以用双向搜索4层来写,但已经不愿意改了,干脆暴搜+剪枝水过去算了. 想到一个很水的剪枝,h函数为  当前点到终点4个点的最短距离加起来除以2,因为最多一步走2格,然后在HDU上T了,又发现再搜索过程中,这个估价函数应该是递减的(贪心),再加上这个剪枝就过了. #include<iostream> #include<cstdio> #include<cstring> #include<string> #include<list> #

HDU 4622 Reincarnation Hash解法详解

今天想学字符串hash是怎么弄的.就看到了这题模板题 http://acm.hdu.edu.cn/showproblem.php?pid=4622 刚开始当然不懂啦,然后就上网搜解法.很多都是什么后缀自动机那些.作为小白的我当然不懂啦,更重要的是我想学的是字符串hash这种解法呢?然而有这种解法,但是却都是只有代码,看起来很辛苦.所以这里我把我的理解写上来,当然有错误的话,请各路高手指出来,我也好好学习下~~ 首先介绍一个字符串Hash的优秀映射函数:BKDRHash,这里hash一开始是等于0

2013 Asia Regional Changchun I 题,HDU(4821),Hash

题目链接:http://acm.split.hdu.edu.cn/showproblem.php?pid=4821 解题报告:搞了很久,总算搞出来了,还是参考了一下网上的解法,的确很巧,和上次湘潭的比赛中的一个求平方和的题目思路很类似. 首先说一下hash,简单来说就是y = hash(x),有很多函数,可以参考这里:https://www.byvoid.com/blog/string-hash-compare/ 然后,我用的是这个:写法简单,而且重复的可能较小. // BKDR Hash Fu

hdu 3973 字符串hash+线段树

http://acm.hdu.edu.cn/showproblem.php?pid=3973 Problem Description You are given some words {Wi}. Then our stupid AC will give you a very long string S. AC is stupid and always wants to know whether one substring from S exists in the given words {Wi}

hdu 4848 搜索+剪枝 2014西安邀请赛

http://acm.hdu.edu.cn/showproblem.php?pid=4848 比赛的时候我甚至没看这道题,其实不难.... 但是说实话,现在对题意还是理解不太好...... 犯的错误: 1.floy循环次序写错, 2.搜索的时候,应该先判断i是不是可以搜(就是可不可能产生解),然后标记vis[i]=1,我二逼的先标记vis[i]=1,然后判断i是不是可搜,这样肯定会导致有些时候,cnt!=n 我的剪枝方法(2546MS AC): 搜下一个结点之前,确保时间小于所有的未访问的结点的